﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Controls.Primitives;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            ObservableCollection<Address> cd = new ObservableCollection<Address>();
            cd.Add(new Address(){ Number = 1, City = "Sofia"});
            cd.Add(new Address() { Number = 2, City = "London" });

            ObservableCollection<Person> d = new ObservableCollection<Person>();
            d.Add(new Person() { ID = 0, Location = cd[0]});
            d.Add(new Person() { ID = 1, Location = cd[1] });
            d.Add(new Person() { ID = 2, Location = cd[1] });
            d.Add(new Person() { ID = 3, Location = cd[0] });

            this.DataContext = new ViewModel() { Data = d, ComboData = cd };
        }
    }

    public class ViewModel
    {
        public ObservableCollection<Person> Data { get; set; }
        public ObservableCollection<Address> ComboData { get; set; }
    }

    public class Address : INotifyPropertyChanged
    {
        private int number;

        public int Number
        {
            get { return number; }
            set 
            { 
                number = value;
                PropChanged("Number");
            }
        }

        private string city;

        public string City
        {
            get { return city; }
            set 
            { 
                city = value;
                PropChanged("City");
            }
        }


        public event PropertyChangedEventHandler PropertyChanged;

        public void PropChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    }



    public class Person : INotifyPropertyChanged
    {
        private int id;

        public int ID
        {
            get { return id; }
            set 
            { 
                id = value;
                PropChanged("ID");
            }
        }

        private Address location;

        public Address Location
        {
            get { return location; }
            set 
            {
                location = value;
                PropChanged("Location");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        public void PropChanged(string name)
        {
            if (PropertyChanged != null)
                PropertyChanged(this, new PropertyChangedEventArgs(name));
        }
    }


				
}
